Bug 1678411 (CVE-2019-3836) - CVE-2019-3836 gnutls: invalid pointer access upon receiving async handshake messages
Summary: CVE-2019-3836 gnutls: invalid pointer access upon receiving async handshake m...
Status: NEW
Alias: CVE-2019-3836
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=moderate,public=20190327,repor...
Keywords: Security
Depends On: 1693288 1693289 1693214
Blocks: 1678414
TreeView+ depends on / blocked
 
Reported: 2019-02-18 17:41 UTC by Pedro Sampaio
Modified: 2019-06-08 23:52 UTC (History)
12 users (show)

(edit)
A flaw was found in the way gnutls handled malformed TLS 1.3 asynchronous messages. An attacker could use this flaw to crash an application compiled with gnutls via invalid pointer access.
Clone Of:
(edit)
Last Closed:


Attachments (Terms of Use)

Description Pedro Sampaio 2019-02-18 17:41:29 UTC
It was discovered in gnutls upstream that there is an uninitialized pointer access in gnutls versions 3.6.4 or later which can be triggered by certain post-handshake messages.

Upstream issue:

https://gitlab.com/gnutls/gnutls/issues/704

Comment 2 Dhananjay Arunesh 2019-03-27 11:17:54 UTC
Created gnutls tracking bugs for this issue:

Affects: fedora-all [bug 1693214]

Comment 4 Hubert Kario 2019-03-27 13:25:48 UTC
the tlsfuzzer[1] test-tls13-keyupdate.py[2] test script can be used in concert with valgrind to verify the fix

 1 - https://github.com/tomato42/tlsfuzzer
 2 - https://github.com/tomato42/tlsfuzzer/pull/501

Comment 5 Leonardo Taccari 2019-03-29 21:58:29 UTC
Hello!
according:

 https://www.gnutls.org/security-new.html#GNUTLS-SA-2019-03-27

it seems that versions since 3.6.4 are affected (not 3.6.3 as originally pointed out by Pedro in the 1st comment).
Is also 3.6.3 affected?


Thanks!

Comment 6 Pedro Sampaio 2019-04-03 21:04:47 UTC
(In reply to Leonardo Taccari from comment #5)
> Hello!
> according:
> 
>  https://www.gnutls.org/security-new.html#GNUTLS-SA-2019-03-27
> 
> it seems that versions since 3.6.4 are affected (not 3.6.3 as originally
> pointed out by Pedro in the 1st comment).
> Is also 3.6.3 affected?
> 
> 
> Thanks!

Yes, I believe you are right. Fixed.

Thank you for pointing that out.

Comment 7 Huzaifa S. Sidhpurwala 2019-04-05 05:47:34 UTC
Acknowledgments:

Name: Hubert Kario (Red Hat QE BaseOS Security team)

Comment 8 Huzaifa S. Sidhpurwala 2019-04-05 05:47:38 UTC
External References:

https://www.gnutls.org/security-new.html#GNUTLS-SA-2019-03-27

Comment 9 Huzaifa S. Sidhpurwala 2019-04-05 05:51:02 UTC
Upstream commit: https://gitlab.com/gnutls/gnutls/commit/96e07075e8f105b13e76b11e493d5aa2dd937226

Comment 10 Hubert Kario 2019-04-05 11:10:00 UTC
(In reply to Huzaifa S. Sidhpurwala from comment #7)
> Acknowledgments:
> 
> Name: Hubert Kario (Red Hat QE BaseOS Security team)

Actually the issue was identified by Daiki Ueno (Red Hat BaseOS Crypto team), I've just slightly extended tests originally written by Róbert Kolcún.


Note You need to log in before you can comment on or make changes to this bug.